"use strict";

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
var _objectSpread2 = _interopRequireDefault(require("reshow-runtime/helpers/objectSpread2"));
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("reshow-runtime/helpers/objectWithoutPropertiesLoose"));
var _react = require("react");
var _reshowBuild = require("reshow-build");
var _reactAtomicMolecule = require("react-atomic-molecule");
var _jsxRuntime = require("react/jsx-runtime");
var _excluded = ["handler", "expose", "boxSizing", "listStyle", "hideList", "list", "icon", "children", "style", "titleStyle", "iconStyle", "textClassName", "compHd", "compBd", "compFt", "className", "refCb"];
var DropdownUI = function DropdownUI(props) {
  injects = (0, _reactAtomicMolecule.useLazyInject)(InjectStyles, injects);
  (0, _reactAtomicMolecule.useCSS)(["dropdown"], "semantic");
  var _props$handler = props.handler,
    handler = _props$handler === void 0 ? {} : _props$handler,
    _props$expose = props.expose,
    expose = _props$expose === void 0 ? {} : _props$expose,
    _props$boxSizing = props.boxSizing,
    boxSizing = _props$boxSizing === void 0 ? "border-box" : _props$boxSizing,
    listStyle = props.listStyle,
    hideList = props.hideList,
    list = props.list,
    _props$icon = props.icon,
    icon = _props$icon === void 0 ? true : _props$icon,
    children = props.children,
    style = props.style,
    titleStyle = props.titleStyle,
    iconStyle = props.iconStyle,
    textClassName = props.textClassName,
    compHd = props.compHd,
    compBd = props.compBd,
    compFt = props.compFt,
    className = props.className,
    _refCb = props.refCb,
    otherProps = (0, _objectWithoutPropertiesLoose2["default"])(props, _excluded);
  var textClasses = (0, _reactAtomicMolecule.mixClass)("text", textClassName);
  var thisText = /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactAtomicMolecule.SemanticUI, {
    className: textClasses,
    style: (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, Styles.label), titleStyle),
    children: children
  });
  var thisIcon = null;
  if (icon) {
    if (! /*#__PURE__*/(0, _react.isValidElement)(icon)) {
      thisIcon = /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactAtomicMolecule.Icon, {
        className: "dropdown-default-icon dropdown icon",
        style: iconStyle
      });
    } else {
      thisIcon = icon;
    }
  }
  var thisList = null;
  if (!hideList && list) {
    thisList = (0, _reactAtomicMolecule.build)(list)({
      style: (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, Styles.list), listStyle),
      refCb: handler.listEl,
      onClick: handler.listClick,
      onTouchStart: handler.touchStart
    });
  }
  var thisClass = (0, _reactAtomicMolecule.mixClass)("dropdown", className);
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_reactAtomicMolecule.SemanticUI, (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, otherProps), {}, {
    style: (0, _objectSpread2["default"])((0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, Styles.container), style), {}, {
      boxSizing: boxSizing
    }),
    className: thisClass,
    refCb: function refCb(el) {
      return (0, _reshowBuild.mergeRef)(el, [handler.thisEl, _refCb]);
    },
    onClick: handler.dropdownClick,
    children: [compHd, thisText, thisIcon, compBd, thisList, compFt]
  }));
};
var _default = exports["default"] = DropdownUI;
var Styles = {
  container: {
    border: "none",
    boxShadow: "none",
    minHeight: "auto"
  },
  label: {
    display: "inline-block"
  },
  list: {
    boxSizing: "inherit",
    maxHeight: "50vh",
    overflow: "auto"
  }
};
var injects;
var InjectStyles = {
  resetSelectionBorderColor: [{
    borderColor: "inherit"
  }, [".selection.active.dropdown .menu.ui", ".ui.selection.active.dropdown:hover .menu.ui"].join(",")],
  defaultIcon: [{
    transform: ["rotate(180deg)"]
  }, [".ui.simple.dropdown:hover .dropdown-default-icon", ".ui.dropdown.active .dropdown-default-icon"].join(",")],
  initMenu: [{
    display: "none !important"
  }, ".ui.simple.dropdown .menu"],
  activeMenu: [{
    display: "block !important"
  }, [".ui.dropdown.active>.menu", ".ui.simple.dropdown:hover>.menu"].join(",")],
  /*https://github.com/fomantic/Fomantic-UI/pull/1209/files*/
  fixMinHeight: [{
    boxSizing: "inherit"
  }, ".ui.dropdown .menu>.item"],
  /*upward*/
  upward: [{
    top: "auto"
  }, [".ui.simple.upward.dropdown .menu", ".ui.simple.upward.active.dropdown>.menu", ".ui.simple.upward.dropdown:hover>.menu"].join(",")]
};
module.exports = exports.default;