"use strict";

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("reshow-runtime/helpers/objectWithoutPropertiesLoose"));
var _objectSpread2 = _interopRequireDefault(require("reshow-runtime/helpers/objectSpread2"));
var _reactAtomicMolecule = require("react-atomic-molecule");
var _callFunc = _interopRequireDefault(require("call-func"));
var _DropdownUI = _interopRequireDefault(require("../molecules/DropdownUI.js"));
var _defaultLocator = _interopRequireDefault(require("../../defaultLocator.js"));
var _jsxRuntime = require("react/jsx-runtime");
var _Divider;
var _excluded = ["icon", "children", "header", "divider"],
  _excluded2 = ["dropdownComponent", "menuComponent", "itemComponent", "labelLocator", "valueLocator", "iconLocator", "headerLocator", "dividerLocator", "itemLocator", "itemsLocator", "highlighter", "onSelect", "useScrollToSelect", "alwaysOpen", "active", "hideTitle", "search", "defaultValue", "value", "placeholder", "options", "name", "onBeforeChange", "onChange", "wrapRefCb", "refCb", "inputProps"]; // @ts-check
var SelectMenu = function SelectMenu(props) {
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactAtomicMolecule.Menu, (0, _objectSpread2["default"])({}, props));
};
var SelectItem = function SelectItem(_ref) {
  var icon = _ref.icon,
    children = _ref.children,
    header = _ref.header,
    divider = _ref.divider,
    props = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);
  var thisIcon;
  if (icon) {
    thisIcon = /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactAtomicMolecule.Icon, {
      children: (0, _reactAtomicMolecule.build)(icon)()
    });
  }
  var comp = [/*#__PURE__*/(0, _jsxRuntime.jsxs)(_reactAtomicMolecule.Item, (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, props), {}, {
    children: [thisIcon, children]
  }), "item")];
  if (divider) {
    comp.unshift(_Divider || (_Divider = /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactAtomicMolecule.Divider, {
      ui: false
    }, "divider")));
  }
  if (header) {
    comp.unshift( /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactAtomicMolecule.Header, {
      ui: false,
      children: header
    }, header));
  }
  return comp;
};
var SelectUI = function SelectUI(props) {
  var _props$dropdownCompon = props.dropdownComponent,
    dropdownComponent = _props$dropdownCompon === void 0 ? _DropdownUI["default"] : _props$dropdownCompon,
    _props$menuComponent = props.menuComponent,
    menuComponent = _props$menuComponent === void 0 ? SelectMenu : _props$menuComponent,
    _props$itemComponent = props.itemComponent,
    itemComponent = _props$itemComponent === void 0 ? SelectItem : _props$itemComponent,
    _props$labelLocator = props.labelLocator,
    labelLocator = _props$labelLocator === void 0 ? _defaultLocator["default"].label : _props$labelLocator,
    _props$valueLocator = props.valueLocator,
    valueLocator = _props$valueLocator === void 0 ? _defaultLocator["default"].value : _props$valueLocator,
    _props$iconLocator = props.iconLocator,
    iconLocator = _props$iconLocator === void 0 ? _defaultLocator["default"].icon : _props$iconLocator,
    _props$headerLocator = props.headerLocator,
    headerLocator = _props$headerLocator === void 0 ? _defaultLocator["default"].header : _props$headerLocator,
    _props$dividerLocator = props.dividerLocator,
    dividerLocator = _props$dividerLocator === void 0 ? _defaultLocator["default"].divider : _props$dividerLocator,
    _props$itemLocator = props.itemLocator,
    itemLocator = _props$itemLocator === void 0 ? _defaultLocator["default"].item : _props$itemLocator,
    _props$itemsLocator = props.itemsLocator,
    itemsLocator = _props$itemsLocator === void 0 ? _defaultLocator["default"].items : _props$itemsLocator,
    _props$highlighter = props.highlighter,
    highlighter = _props$highlighter === void 0 ? function (d) {
      return d;
    } : _props$highlighter,
    _props$onSelect = props.onSelect,
    onSelect = _props$onSelect === void 0 ? function () {} : _props$onSelect,
    _props$useScrollToSel = props.useScrollToSelect,
    useScrollToSelect = _props$useScrollToSel === void 0 ? [] : _props$useScrollToSel,
    alwaysOpen = props.alwaysOpen,
    active = props.active,
    hideTitle = props.hideTitle,
    search = props.search,
    defaultValue = props.defaultValue,
    value = props.value,
    placeholder = props.placeholder,
    options = props.options,
    name = props.name,
    onBeforeChange = props.onBeforeChange,
    onChange = props.onChange,
    wrapRefCb = props.wrapRefCb,
    refCb = props.refCb,
    inputProps = props.inputProps,
    restProps = (0, _objectWithoutPropertiesLoose2["default"])(props, _excluded2);
  var thisPlaceholder = null;
  if (placeholder) {
    thisPlaceholder = /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactAtomicMolecule.SemanticUI, {
      style: Styles.dropdownPlaceholder,
      children: placeholder
    });
  }
  var thisSelected = value;
  var thisList = null;
  var _callfunc = (0, _callFunc["default"])(useScrollToSelect, [props]),
    lastRoot = _callfunc[0];
  if (options && options.length) {
    var prevHeader;
    thisList = (0, _reactAtomicMolecule.build)(menuComponent)(null, itemsLocator(options).map(function (l, itemIndex) {
      l = itemLocator(l);
      var optionValue = valueLocator(l);
      var optionText = labelLocator(l);
      var itemIcon = iconLocator(l);
      var header = headerLocator(l);
      var divider = dividerLocator(l);
      var active = null;
      if (value === optionValue) {
        thisSelected = optionText;
        active = true;
      }
      var thisHeader = null;
      if (header !== prevHeader) {
        prevHeader = header;
        thisHeader = header;
      }
      var selected = restProps["data-selected-index"] === itemIndex;
      return (0, _reactAtomicMolecule.build)(itemComponent)({
        key: optionValue,
        onClick: onSelect(l),
        "data-v": optionValue,
        "data-item-inex": itemIndex,
        className: (0, _reactAtomicMolecule.mixClass)({
          active: active,
          selected: selected
        }),
        icon: itemIcon,
        header: thisHeader,
        divider: divider
      }, highlighter(optionText, optionValue, l));
    }));
  }
  var inputAttr;
  if (search) {
    inputAttr = {
      className: "search",
      placeholder: "Type or search a command",
      style: {
        border: "none",
        boxSizing: "border-box"
      },
      type: "search"
    };
  } else {
    inputAttr = {
      type: "hidden"
    };
  }
  var compHd = /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactAtomicMolecule.SemanticUI, (0, _objectSpread2["default"])({
    atom: "input",
    refCb: refCb,
    name: name,
    value: value || ""
  }, (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, inputAttr), inputProps)), "input");
  var handleWrapRefCb = function handleWrapRefCb(el) {
    return (0, _reactAtomicMolecule.mergeRef)(el, [wrapRefCb, lastRoot]);
  };
  return (0, _reactAtomicMolecule.build)(dropdownComponent)((0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, restProps), {}, {
    refCb: handleWrapRefCb,
    list: thisList,
    compHd: compHd,
    className: (0, _reactAtomicMolecule.mixClass)(props.className, "selection", {
      search: search,
      active: alwaysOpen || active
    })
  }), hideTitle ? null : thisSelected || thisPlaceholder);
};
var _default = exports["default"] = SelectUI;
var Styles = {
  dropdownPlaceholder: {
    color: "#ccc"
  }
};
module.exports = exports.default;