"use strict";

var _interopRequireWildcard = require("reshow-runtime/helpers/interopRequireWildcard");
var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
var _objectSpread2 = _interopRequireDefault(require("reshow-runtime/helpers/objectSpread2"));
var _classCallCheck2 = _interopRequireDefault(require("reshow-runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("reshow-runtime/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("reshow-runtime/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("reshow-runtime/helpers/inherits"));
var _createSuper2 = _interopRequireDefault(require("reshow-runtime/helpers/createSuper"));
var _defineProperty2 = _interopRequireDefault(require("reshow-runtime/helpers/defineProperty"));
var React = _interopRequireWildcard(require("react"));
var _reactAtomicMolecule = require("react-atomic-molecule");
var _getObjectValue = _interopRequireDefault(require("get-object-value"));
var _Dropdown = _interopRequireDefault(require("ricon/Dropdown"));
var _jsxRuntime = require("react/jsx-runtime");
//@ts-check

var PureComponent = React.PureComponent;
var AccordionItem = function AccordionItem(_ref) {
  var title = _ref.title,
    content = _ref.content,
    iconLeft = _ref.iconLeft,
    iconRight = _ref.iconRight,
    titleClasses = _ref.titleClasses,
    contentClasses = _ref.contentClasses,
    onClick = _ref.onClick;
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_reactAtomicMolecule.Item, {
    children: [/*#__PURE__*/(0, _jsxRuntime.jsxs)(_reactAtomicMolecule.Title, {
      onClick: onClick,
      className: titleClasses,
      children: [iconLeft, title, iconRight]
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactAtomicMolecule.Content, {
      className: contentClasses,
      children: content
    })]
  });
};
var Accordion = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(Accordion, _PureComponent);
  var _super = (0, _createSuper2["default"])(Accordion);
  function Accordion() {
    var _this;
    (0, _classCallCheck2["default"])(this, Accordion);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      isActives: {}
    });
    return _this;
  }
  (0, _createClass2["default"])(Accordion, [{
    key: "handleClick",
    value:
    /**
     * @param {string} name
     */
    function handleClick(name) {
      this.setState(function (_ref2) {
        var isActives = _ref2.isActives;
        isActives[name] = !(0, _getObjectValue["default"])(isActives, [name], false);
        return (0, _objectSpread2["default"])({}, isActives);
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props = this.props,
        className = _this$props.className,
        items = _this$props.items,
        iconLocRight = _this$props.iconLocRight,
        iconLocLeft = _this$props.iconLocLeft,
        iconOpen = _this$props.iconOpen,
        iconClose = _this$props.iconClose;
      var isActives = this.state.isActives;
      var classes = (0, _reactAtomicMolecule.mixClass)("accordion", className);
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactAtomicMolecule.SemanticUI, {
        className: classes,
        children: items.map(
        /**
         * @param {any} item
         * @param {number} key
         */
        function (item, key) {
          var itemProps = (0, _getObjectValue["default"])(item, ["props"], {});
          var name = itemProps.name || key;
          var isActive = !!isActives[name];
          var titleClasses = (0, _reactAtomicMolecule.mixClass)({
            active: isActive
          });
          var contentClasses = (0, _reactAtomicMolecule.mixClass)({
            active: isActive
          });
          var icon = /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactAtomicMolecule.Icon, {
            style: Styles.icon,
            children: isActive ? iconOpen : iconClose
          });
          var iconLeft;
          var iconRight;
          if (iconLocRight) {
            iconRight = icon;
          } else if (iconLocLeft) {
            iconLeft = icon;
          }
          return /*#__PURE__*/(0, _jsxRuntime.jsx)(AccordionItem, (0, _objectSpread2["default"])({}, (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, item), {}, {
            name: name,
            titleClasses: titleClasses,
            contentClasses: contentClasses,
            iconLeft: iconLeft,
            iconRight: iconRight,
            key: name,
            onClick: _this2.handleClick.bind(_this2, name)
          })));
        })
      });
    }
  }]);
  return Accordion;
}(PureComponent);
(0, _defineProperty2["default"])(Accordion, "defaultProps", {
  iconOpen: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Dropdown["default"], {}),
  iconClose: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Dropdown["default"], {
    type: "left"
  }),
  iconLocRight: true,
  iconLocLeft: false
});
var _default = exports["default"] = Accordion;
var Styles = {
  icon: {
    width: 24,
    height: 24
  }
};
module.exports = exports.default;