"use strict";

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
var _objectSpread2 = _interopRequireDefault(require("reshow-runtime/helpers/objectSpread2"));
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("reshow-runtime/helpers/objectWithoutPropertiesLoose"));
var _react = require("react");
var _reactAtomicMolecule = require("react-atomic-molecule");
var _getObjectValue = _interopRequireDefault(require("get-object-value"));
var _jsxRuntime = require("react/jsx-runtime");
var _SemanticUI;
var _excluded = ["className", "children", "divider", "dividerStyle", "style"];
var Breadcrumb = function Breadcrumb(props) {
  var className = props.className,
    children = props.children,
    divider = props.divider,
    dividerStyle = props.dividerStyle,
    style = props.style,
    reset = (0, _objectWithoutPropertiesLoose2["default"])(props, _excluded);
  var itemList = [];
  var defaultDivider = (0, _reactAtomicMolecule.build)(divider || _SemanticUI || (_SemanticUI = /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactAtomicMolecule.SemanticUI, {
    children: " / "
  })));
  _react.Children.forEach(children, function (node, k) {
    if (!node) {
      return;
    }
    var nodeProps = (0, _getObjectValue["default"])(node, ["props"], {});
    itemList.push((0, _reactAtomicMolecule.build)(node)({
      key: k,
      className: (0, _reactAtomicMolecule.mixClass)(nodeProps.className, "section")
    }));
    var nodeDataDivider = nodeProps["data-divider"];
    var thisDivider = nodeDataDivider ? (0, _reactAtomicMolecule.build)(nodeDataDivider) : defaultDivider;
    var dividerProps = (0, _getObjectValue["default"])(divider, ["props"], function () {
      return (0, _getObjectValue["default"])(nodeProps.divider, ["props"], {});
    });
    itemList.push(thisDivider({
      key: k + "-div",
      style: (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, dividerProps.style), dividerStyle),
      className: (0, _reactAtomicMolecule.mixClass)(dividerProps.className, "divider")
    }));
  });
  if (itemList.length) {
    itemList.pop();
  }
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactAtomicMolecule.SemanticUI, (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, reset), {}, {
    style: (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, Styles.container), style),
    className: (0, _reactAtomicMolecule.mixClass)("breadcrumb", className),
    children: itemList
  }));
};
var _default = exports["default"] = Breadcrumb;
var Styles = {
  container: {
    lineHeight: 1.8
  }
};
module.exports = exports.default;