"use strict";

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("reshow-runtime/helpers/objectWithoutPropertiesLoose"));
var _objectSpread2 = _interopRequireDefault(require("reshow-runtime/helpers/objectSpread2"));
var _callFunc = _interopRequireDefault(require("call-func"));
var _getObjectValue = _interopRequireDefault(require("get-object-value"));
var _reactAtomicMolecule = require("react-atomic-molecule");
var _jsxRuntime = require("react/jsx-runtime");
var _react = require("react");
var _excluded = ["isLastPage", "text"],
  _excluded2 = ["text"];
var isArray = Array.isArray;
var plusOne = function plusOne(i) {
  return i + 1;
};
var getFromTo = function getFromTo(from, to) {
  return plusOne(from) + "-" + plusOne(to);
};
var keys = Object.keys;
var BasePage = function BasePage(props) {
  var onPageChange = props.onPageChange,
    component = props.component,
    className = props.className,
    children = props.children,
    style = props.style,
    url = props.url,
    rel = props.rel;
  var classes = (0, _reactAtomicMolecule.mixClass)((0, _getObjectValue["default"])(component, ["props", "className"]), className, "item link");
  var onClick = onPageChange ? function () {
    return (0, _callFunc["default"])(onPageChange, [{
      begin: props[0],
      end: props[1],
      page: props["currentPage"],
      perPageNum: props["perPageNum"]
    }]);
  } : null;
  return (0, _reactAtomicMolecule.build)(component)({
    rel: rel,
    title: getFromTo(props[0], props[1]),
    className: classes,
    href: url,
    style: style,
    onClick: onClick,
    "data-begin": props[0],
    "data-end": props[1],
    "data-page": props["currentPage"],
    "data-per-page-num": props["perPageNum"]
  }, children);
};
var Page = function Page(props) {
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(BasePage, (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, props), {}, {
    children: props.currentPage
  }));
};
var Forward = function Forward(_ref) {
  var isLastPage = _ref.isLastPage,
    text = _ref.text,
    props = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(BasePage, (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, props), {}, {
    rel: "next",
    children: isLastPage ? props.currentPage : text
  }));
};
var Backward = function Backward(_ref2) {
  var text = _ref2.text,
    props = (0, _objectWithoutPropertiesLoose2["default"])(_ref2, _excluded2);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(BasePage, (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, props), {}, {
    rel: "prev",
    children: props.currentPage === 1 ? props.currentPage : text
  }));
};
var Current = function Current(props) {
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactAtomicMolecule.Item, {
    style: props.style,
    title: getFromTo(props[0], props[1]),
    className: (0, _reactAtomicMolecule.mixClass)("active", props.className),
    children: props.currentPage
  });
};
var FirstPage = function FirstPage(props) {
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(Page, (0, _objectSpread2["default"])({}, props));
};
var LastPage = function LastPage(props) {
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(Page, (0, _objectSpread2["default"])({}, props));
};
var Ellipsis = function Ellipsis(props) {
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactAtomicMolecule.Item, {
    className: "disabled ellipsis",
    style: (0, _objectSpread2["default"])({
      minWidth: 0,
      width: 0
    }, props.style),
    children: "..."
  });
};
var Pagination = function Pagination(pg) {
  injects = (0, _reactAtomicMolecule.useLazyInject)(InjectStyles, injects);
  var linkComponent = pg.linkComponent,
    onPageChange = pg.onPageChange,
    forwardText = pg.forwardText,
    backwardText = pg.backwardText,
    ui = pg.ui,
    _pg$currentPageProps = pg.currentPageProps,
    currentPageProps = _pg$currentPageProps === void 0 ? {} : _pg$currentPageProps;
  var firstPage;
  var firstEllipsis;
  var lastPage;
  var lastEllipsis;
  var pageProps = pg.pageProps || {};
  pageProps.onPageChange = onPageChange;
  pageProps.component = linkComponent;
  var ellipsisProps = (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, pageProps), {}, {
    onPageChange: null
  });
  if (pg.firstPage) {
    firstPage = /*#__PURE__*/(0, _jsxRuntime.jsx)(FirstPage, (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, pg.firstPage), pageProps));
    firstEllipsis = /*#__PURE__*/(0, _jsxRuntime.jsx)(Ellipsis, (0, _objectSpread2["default"])({}, ellipsisProps));
  }
  if (pg.lastPage) {
    lastPage = /*#__PURE__*/(0, _jsxRuntime.jsx)(LastPage, (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, pg.lastPage), pageProps));
    lastEllipsis = /*#__PURE__*/(0, _jsxRuntime.jsx)(Ellipsis, (0, _objectSpread2["default"])({}, ellipsisProps));
  }
  var pgList = pg.list;
  if (!isArray(pgList)) {
    console.error("Page list not array", pg);
  }
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_reactAtomicMolecule.Menu, {
    className: "compact pagination",
    ui: ui,
    children: [firstPage, firstEllipsis, pgList.map(function (v, k) {
      var current = pg.currentPage;
      if (v.currentPage) {
        if (current.backward && current.backward.currentPage === v.currentPage || current.forward && current.forward.currentPage === v.currentPage) {
          return null;
        }
        return /*#__PURE__*/(0, _react.createElement)(Page, (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, pageProps), {}, {
          key: k
        }, v));
      } else {
        var re = [];
        if (current.backward) {
          re.push( /*#__PURE__*/(0, _jsxRuntime.jsx)(Backward, (0, _objectSpread2["default"])((0, _objectSpread2["default"])((0, _objectSpread2["default"])({
            text: backwardText
          }, current.backward), pageProps), {}, {
            style: (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, pageProps.style), {}, {
              display: "flex"
            })
          })));
        }
        re.push( /*#__PURE__*/(0, _jsxRuntime.jsx)(Current, (0, _objectSpread2["default"])((0, _objectSpread2["default"])((0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, pageProps), current), currentPageProps), {}, {
          style: (0, _objectSpread2["default"])((0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, pageProps.style), currentPageProps.style), {}, {
            display: "flex"
          })
        }), k));
        if (current.forward) {
          re.push( /*#__PURE__*/(0, _jsxRuntime.jsx)(Forward, (0, _objectSpread2["default"])((0, _objectSpread2["default"])((0, _objectSpread2["default"])({
            isLastPage: pgList.length - 2 === k
          }, current.forward), {}, {
            text: forwardText
          }, pageProps), {}, {
            style: (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, pageProps.style), {}, {
              display: "flex"
            })
          })));
        }
        return re;
      }
    }), lastEllipsis, lastPage]
  });
};
Pagination.defaultProps = {
  linkComponent: "a",
  forwardText: "> Next",
  backwardText: "<"
};
var _default = exports["default"] = Pagination;
var injects;
var pgCssSelector = ".pagination.ui.menu:not(.vertical) .item";
var InjectStyles = {
  hidePg: [{
    display: "none",
    minWidth: "2rem",
    justifyContent: "center"
  }, pgCssSelector],
  showPg: [{
    display: "flex"
  }, [_reactAtomicMolecule.min.sm, pgCssSelector]]
};
module.exports = exports.default;