"use strict";

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");
var _interopRequireWildcard = require("reshow-runtime/helpers/interopRequireWildcard");
exports.__esModule = true;
exports["default"] = void 0;
var _objectSpread2 = _interopRequireDefault(require("reshow-runtime/helpers/objectSpread2"));
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("reshow-runtime/helpers/objectWithoutPropertiesLoose"));
var _classCallCheck2 = _interopRequireDefault(require("reshow-runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("reshow-runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("reshow-runtime/helpers/inherits"));
var _createSuper2 = _interopRequireDefault(require("reshow-runtime/helpers/createSuper"));
var _defineProperty2 = _interopRequireDefault(require("reshow-runtime/helpers/defineProperty"));
var _react = require("react");
var _reactAtomicMolecule = require("react-atomic-molecule");
var _toPercentJs = require("to-percent-js");
var _getObjectValue = _interopRequireDefault(require("get-object-value"));
var _Pagination = _interopRequireDefault(require("../organisms/Pagination.js"));
var _paginationCalculator = _interopRequireWildcard(require("../../paginationCalculator.js"));
var _jsxRuntime = require("react/jsx-runtime");
var _excluded = ["hideOnlyOne", "pageProps", "currentPageProps", "onPageChange", "pageListNumber", "total", "begin", "currentPage", "perPageNum", "ui"];
var PaginationController = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2["default"])(PaginationController, _PureComponent);
  var _super = (0, _createSuper2["default"])(PaginationController);
  function PaginationController() {
    (0, _classCallCheck2["default"])(this, PaginationController);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(PaginationController, [{
    key: "getPaginationData",
    value: function getPaginationData() {
      if (!this.cal) {
        this.cal = new _paginationCalculator["default"]();
      }
      var cal = this.cal;
      var _this$props = this.props,
        pageListNumber = _this$props.pageListNumber,
        total = _this$props.total,
        begin = _this$props.begin,
        currentPage = _this$props.currentPage,
        perPageNum = _this$props.perPageNum;
      cal.set(_paginationCalculator.TOTAL, (0, _toPercentJs.toInt)(total));
      if (null != perPageNum) {
        cal.set(_paginationCalculator.PER_PAGE_NUM, (0, _toPercentJs.toInt)(perPageNum));
      }
      if (null != begin) {
        cal.set(_paginationCalculator.BEGIN, (0, _toPercentJs.toInt)(begin));
      } else {
        cal.set(_paginationCalculator.BEGIN, null); // when "type = page" need reset begin
        cal.set(_paginationCalculator.CURRENT_PAGE, (0, _toPercentJs.toInt)(currentPage));
      }
      return cal.genPageList((0, _toPercentJs.toInt)(pageListNumber));
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
        hideOnlyOne = _this$props2.hideOnlyOne,
        pageProps = _this$props2.pageProps,
        currentPageProps = _this$props2.currentPageProps,
        onPageChange = _this$props2.onPageChange,
        pageListNumber = _this$props2.pageListNumber,
        total = _this$props2.total,
        begin = _this$props2.begin,
        currentPage = _this$props2.currentPage,
        perPageNum = _this$props2.perPageNum,
        ui = _this$props2.ui,
        otherProps = (0, _objectWithoutPropertiesLoose2["default"])(_this$props2, _excluded);
      var data = this.getPaginationData();
      if (hideOnlyOne) {
        var liLen = (0, _getObjectValue["default"])(data.list, ["length"], 0);
        if (liLen < 2) {
          return null;
        }
      }
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactAtomicMolecule.SemanticUI, (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, otherProps), {}, {
        ui: ui,
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Pagination["default"], (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, data), {}, {
          onPageChange: onPageChange,
          ui: ui,
          pageProps: pageProps,
          currentPageProps: currentPageProps
        }))
      }));
    }
  }]);
  return PaginationController;
}(_react.PureComponent);
(0, _defineProperty2["default"])(PaginationController, "defaultProps", {
  perPageNum: 10
});
var _default = exports["default"] = PaginationController;
module.exports = exports.default;