"use strict";

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
var _objectSpread2 = _interopRequireDefault(require("reshow-runtime/helpers/objectSpread2"));
var _react = require("react");
var _SelectUI = _interopRequireDefault(require("../molecules/SelectUI.js"));
var _Dropdown = _interopRequireDefault(require("../organisms/Dropdown.js"));
var _useSelect2 = require("../../hooks/useSelect.js");
var _jsxRuntime = require("react/jsx-runtime");
// @ts-check

/**
 * @type React.FC<any>
 * @returns {React.ReactElement}
 */var Select = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var _useSelect = (0, _useSelect2.useSelect)(props),
    handler = _useSelect.handler,
    expose = _useSelect.expose,
    labelLocator = _useSelect.labelLocator,
    valueLocator = _useSelect.valueLocator;
  (0, _react.useImperativeHandle)(ref, function () {
    return expose;
  }, []);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_SelectUI["default"], (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, props), {}, {
    labelLocator: labelLocator,
    valueLocator: valueLocator,
    dropdownComponent: _Dropdown["default"],
    value: expose.getValue(),
    onSelect: handler.select
  }));
});
Select.displayName = "Select";
var _default = exports["default"] = Select;
module.exports = exports.default;