"use strict";

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");
var _interopRequireWildcard = require("reshow-runtime/helpers/interopRequireWildcard");
exports.__esModule = true;
exports["default"] = void 0;
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("reshow-runtime/helpers/objectWithoutPropertiesLoose"));
var _objectSpread2 = _interopRequireDefault(require("reshow-runtime/helpers/objectSpread2"));
var _react = require("react");
var _reactAtomicMolecule = require("react-atomic-molecule");
var _reshowFlux = require("reshow-flux");
var _HamburgerToArrow = _interopRequireDefault(require("ricon/HamburgerToArrow"));
var _getObjectValue = require("get-object-value");
var _classLib = require("class-lib");
var _cssQuerySelector = require("css-query-selector");
var _getoffset = _interopRequireDefault(require("getoffset"));
var _callFunc = _interopRequireDefault(require("call-func"));
var _reshowConstant = require("reshow-constant");
var _navigationStore = _interopRequireWildcard(require("../../stores/navigationStore.js"));
var _jsxRuntime = require("react/jsx-runtime");
var _DefaultIcon, _DefaultIcon2;
var _excluded = ["buildComp", "className", "name", "text", "type"],
  _excluded2 = ["type", "component", "linkComponent", "menus", "rootActiveClass", "rootInactiveClass", "root", "on", "onSwitch", "defaultOnIcon", "defaultOffIcon", "iconStyle", "hamburgerStyle", "className", "menuOrder", "shrink"];
var getMenuByArray = function getMenuByArray(onClick) {
  return function (arr, component, type, menuOrder) {
    if (!arr) {
      return null;
    }
    var results = [];
    var buildComp = (0, _reactAtomicMolecule.build)(component);
    (menuOrder || (0, _reshowConstant.KEYS)(arr)).forEach(function (key) {
      results.push( /*#__PURE__*/(0, _react.createElement)(SideMenuItem, (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, arr[key]), {}, {
        key: key,
        type: type,
        name: key,
        onClick: onClick,
        buildComp: buildComp
      })));
    });
    return results;
  };
};
var SideMenuItem = function SideMenuItem(props) {
  var buildComp = props.buildComp,
    className = props.className,
    name = props.name,
    text = props.text,
    type = props.type,
    others = (0, _objectWithoutPropertiesLoose2["default"])(props, _excluded);
  var lastV = (0, _react.useRef)();
  var active = (0, _reshowFlux.useStore)(_navigationStore["default"], function (emit) {
    if (emit === void 0) {
      emit = {};
    }
    var _ref = emit.current || {},
      storeState = _ref.storeState,
      notify = _ref.notify;
    if (emit.current) {
      var _storeState$get = storeState.get(type),
        activeMenu = _storeState$get.activeMenu;
      if (name !== activeMenu && lastV.current) {
        emit.current.state = false;
        notify();
      } else if (name === activeMenu) {
        emit.current.state = true;
        notify();
        lastV.current = true;
      }
    } else {
      return false;
    }
  });
  var classes = (0, _reactAtomicMolecule.mixClass)(className, "item", {
    active: active
  });
  return buildComp((0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, others), {}, {
    className: classes,
    name: name
  }), text);
};
var DefaultIcon = function DefaultIcon(_ref2) {
  var className = _ref2.className,
    on = _ref2.on,
    right = _ref2.right,
    onClick = _ref2.onClick,
    iconStyle = _ref2.iconStyle,
    hamburgerStyle = _ref2.hamburgerStyle;
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactAtomicMolecule.Icon, {
    onClick: onClick,
    className: (0, _reactAtomicMolecule.mixClass)(className, "hamburger-icon"),
    styles: (0, _reactAtomicMolecule.reactStyle)((0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, Styles.icon), iconStyle), false, false),
    children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_HamburgerToArrow["default"], {
      on: on,
      right: right,
      styles: (0, _reactAtomicMolecule.reactStyle)((0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, Styles.hamburger), hamburgerStyle), false, false)
    })
  });
};
var SideMenuContainer = function SideMenuContainer(_ref3) {
  var children = _ref3.children,
    type = _ref3.type,
    onSwitch = _ref3.onSwitch,
    lastOn = _ref3.lastOn,
    updateRoot = _ref3.updateRoot,
    defaultOnIcon = _ref3.defaultOnIcon,
    defaultOffIcon = _ref3.defaultOffIcon,
    iconStyle = _ref3.iconStyle,
    hamburgerStyle = _ref3.hamburgerStyle,
    className = _ref3.className,
    shrink = _ref3.shrink;
  var on = (0, _reshowFlux.useStore)(_navigationStore["default"], function (emit) {
    if (emit === void 0) {
      emit = {};
    }
    var _ref4 = emit.current || {},
      storeState = _ref4.storeState,
      notify = _ref4.notify;
    if (emit.current) {
      var _storeState$get2 = storeState.get(type),
        _on = _storeState$get2.on;
      if (lastOn.current !== _on) {
        emit.current.state = _on;
        notify();
        lastOn.current = _on;
        updateRoot(_on);
      }
    } else {
      return lastOn.current;
    }
  });
  var isInit = null == on;

  // setup thisDefaultOffIcon
  var defaultOff = isInit ? false : on;
  var thisDefaultOffIcon = defaultOffIcon;
  if (!thisDefaultOffIcon) {
    thisDefaultOffIcon = _DefaultIcon || (_DefaultIcon = /*#__PURE__*/(0, _jsxRuntime.jsx)(DefaultIcon, {}));
  }
  thisDefaultOffIcon = (0, _reactAtomicMolecule.build)(thisDefaultOffIcon)({
    on: defaultOff,
    onClick: onSwitch(defaultOff),
    className: "default-off",
    iconStyle: iconStyle,
    hamburgerStyle: hamburgerStyle
  });

  // setup thisDefaultOnIcon
  var thisDefaultOnIcon = null;
  if (shrink) {
    var defaultOn = isInit ? true : on;
    thisDefaultOnIcon = defaultOnIcon;
    if (!thisDefaultOnIcon) {
      thisDefaultOnIcon = _DefaultIcon2 || (_DefaultIcon2 = /*#__PURE__*/(0, _jsxRuntime.jsx)(DefaultIcon, {}));
    }
    thisDefaultOnIcon = (0, _reactAtomicMolecule.build)(thisDefaultOnIcon)({
      on: true,
      right: !defaultOn,
      onClick: onSwitch(defaultOn),
      className: "default-on",
      iconStyle: iconStyle,
      hamburgerStyle: hamburgerStyle
    });
  }
  var classes = (0, _reactAtomicMolecule.mixClass)({
    active: on,
    inactive: on === false
  }, "sidebar-menu", className);
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_reactAtomicMolecule.Rail, {
    className: classes,
    children: [children, thisDefaultOnIcon, thisDefaultOffIcon]
  });
};
var useSideMenu = function useSideMenu(props) {
  var _ref5 = props || {},
    _ref5$type = _ref5.type,
    type = _ref5$type === void 0 ? "default" : _ref5$type,
    _ref5$component = _ref5.component,
    component = _ref5$component === void 0 ? _reactAtomicMolecule.SemanticUI : _ref5$component,
    _ref5$linkComponent = _ref5.linkComponent,
    linkComponent = _ref5$linkComponent === void 0 ? "a" : _ref5$linkComponent,
    _ref5$menus = _ref5.menus,
    menus = _ref5$menus === void 0 ? [] : _ref5$menus,
    _ref5$rootActiveClass = _ref5.rootActiveClass,
    rootActiveClass = _ref5$rootActiveClass === void 0 ? "side-menu-active" : _ref5$rootActiveClass,
    _ref5$rootInactiveCla = _ref5.rootInactiveClass,
    rootInactiveClass = _ref5$rootInactiveCla === void 0 ? "side-menu-inactive" : _ref5$rootInactiveCla,
    root = _ref5.root,
    propsOn = _ref5.on,
    onSwitch = _ref5.onSwitch,
    defaultOnIcon = _ref5.defaultOnIcon,
    defaultOffIcon = _ref5.defaultOffIcon,
    iconStyle = _ref5.iconStyle,
    hamburgerStyle = _ref5.hamburgerStyle,
    className = _ref5.className,
    menuOrder = _ref5.menuOrder,
    shrink = _ref5.shrink,
    others = (0, _objectWithoutPropertiesLoose2["default"])(_ref5, _excluded2);
  var lastOn = (0, _react.useRef)();
  (0, _react.useEffect)(function () {
    if (null != propsOn) {
      (0, _navigationStore.navigationDispatch)(type, {
        on: propsOn
      });
    }
  }, [propsOn]);
  (0, _react.useEffect)(function () {
    return function () {
      var thisRoot = getRoot();
      thisRoot.className = (0, _classLib.removeClass)(thisRoot.className, rootActiveClass);
      thisRoot.className = (0, _classLib.removeClass)(thisRoot.className, rootInactiveClass);
    };
  }, []);
  var getRoot = (0, _react.useCallback)(function () {
    return root !== null && root !== void 0 ? root : document.body;
  }, [root]);
  var updateRoot = (0, _react.useCallback)(function (on) {
    var thisRoot = getRoot();
    if (!thisRoot) {
      console.wanr("root not found");
      return;
    }
    if (on) {
      thisRoot.className = (0, _reactAtomicMolecule.mixClass)(thisRoot.className, rootActiveClass);
      thisRoot.className = (0, _classLib.removeClass)(thisRoot.className, rootInactiveClass);
    } else {
      thisRoot.className = (0, _reactAtomicMolecule.mixClass)(thisRoot.className, rootInactiveClass);
      thisRoot.className = (0, _classLib.removeClass)(thisRoot.className, rootActiveClass);
    }
  }, [rootActiveClass, rootInactiveClass]);
  var handleSwitch = (0, _react.useCallback)(function (stateOn) {
    return function (e) {
      var isValidStateOn = "boolean" === typeof stateOn;
      var on = !(isValidStateOn ? stateOn : lastOn.current);
      var defaultOff = (0, _getoffset["default"])((0, _cssQuerySelector.queryOne)(".sidebar-menu .default-off"));
      var isSet = isValidStateOn || defaultOff.w && defaultOff.h;
      if (isSet) {
        (0, _navigationStore.navigationDispatch)(type, {
          on: on
        });
      }
      e.on = on;
      e.isSet = isSet;
      (0, _callFunc["default"])(onSwitch, [e, on, isSet]);
    };
  }, [type, onSwitch]);
  var menuItems = getMenuByArray(handleSwitch())((0, _getObjectValue.toJS)(menus), linkComponent, type, (0, _getObjectValue.toJS)(menuOrder));
  return {
    menuItems: menuItems,
    component: component,
    type: type,
    handleSwitch: handleSwitch,
    lastOn: lastOn,
    updateRoot: updateRoot,
    defaultOnIcon: defaultOnIcon,
    defaultOffIcon: defaultOffIcon,
    iconStyle: iconStyle,
    hamburgerStyle: hamburgerStyle,
    className: className,
    shrink: shrink,
    others: others
  };
};
var SideMenu = function SideMenu(props) {
  var _useSideMenu = useSideMenu(props),
    menuItems = _useSideMenu.menuItems,
    component = _useSideMenu.component,
    type = _useSideMenu.type,
    handleSwitch = _useSideMenu.handleSwitch,
    lastOn = _useSideMenu.lastOn,
    updateRoot = _useSideMenu.updateRoot,
    defaultOnIcon = _useSideMenu.defaultOnIcon,
    defaultOffIcon = _useSideMenu.defaultOffIcon,
    iconStyle = _useSideMenu.iconStyle,
    hamburgerStyle = _useSideMenu.hamburgerStyle,
    className = _useSideMenu.className,
    shrink = _useSideMenu.shrink,
    others = _useSideMenu.others;
  var menuElement = (0, _reactAtomicMolecule.build)(component)(others, menuItems);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(SideMenuContainer, {
    type: type,
    onSwitch: handleSwitch,
    lastOn: lastOn,
    updateRoot: updateRoot,
    defaultOnIcon: defaultOnIcon,
    defaultOffIcon: defaultOffIcon,
    iconStyle: iconStyle,
    hamburgerStyle: hamburgerStyle,
    className: className,
    shrink: shrink,
    children: menuElement
  });
};
var _default = exports["default"] = SideMenu;
var Styles = {
  icon: {
    display: null,
    background: "#000",
    padding: 5,
    width: 24,
    height: 24,
    position: "fixed",
    top: 0,
    left: 0,
    zIndex: 1,
    cursor: "pointer",
    opacity: ".5",
    transition: ["all 0.2s ease-out"]
  },
  hamburger: {
    fill: "#fff"
  }
};
module.exports = exports.default;