"use strict";

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
var _objectSpread2 = _interopRequireDefault(require("reshow-runtime/helpers/objectSpread2"));
var _react = require("react");
var _reactAtomicMolecule = require("react-atomic-molecule");
var _callFunc = _interopRequireDefault(require("call-func"));
var _jsxRuntime = require("react/jsx-runtime");
var handleTabPress = function handleTabPress(_ref) {
  var disableSwitch = _ref.disableSwitch,
    nodeKey = _ref.nodeKey,
    nodeProps = _ref.nodeProps,
    setLastSelected = _ref.setLastSelected,
    thisSelected = _ref.thisSelected,
    onTabItemPress = _ref.onTabItemPress,
    onTabItemWillPress = _ref.onTabItemWillPress;
  return function (e) {
    var isContinue = false !== (0, _callFunc["default"])(onTabItemWillPress, [{
      nodeKey: nodeKey,
      selected: thisSelected.current
    }]);
    if (!disableSwitch && isContinue) {
      if (!nodeProps.disableSwitch) {
        setLastSelected(nodeKey);
        thisSelected.current = nodeKey;
      }
    }
    e.selected = thisSelected.current;
    e.nodeKey = nodeKey;
    (0, _callFunc["default"])(onTabItemPress, [thisSelected.current, e]);
  };
};
var handleSelected = function handleSelected(_ref2) {
  var children = _ref2.children,
    nextSelect = _ref2.nextSelect,
    setLastSelected = _ref2.setLastSelected,
    thisSelected = _ref2.thisSelected,
    disableSwitch = _ref2.disableSwitch,
    onTabItemWillPress = _ref2.onTabItemWillPress,
    onTabItemPress = _ref2.onTabItemPress;
  var tabMenuItems = [];
  var contentView = null;
  var hasSelected = false;
  _react.Children.map(children, function (item, itemKey) {
    var itemProps = item.props;
    // Detect selected
    var nodeKey = "name" in itemProps ? itemProps.name : itemKey;
    if (true === nextSelect) {
      nextSelect = nodeKey;
    }
    thisSelected.current = nextSelect;
    var isActived = nodeKey === nextSelect;
    if (isActived && !hasSelected) {
      hasSelected = true;
    }
    _react.Children.map(itemProps.children, function (node, index) {
      if (index % 2 || 1 === _react.Children.count(itemProps.children)) {
        var _node;
        var nodeProps = ((_node = node) === null || _node === void 0 ? void 0 : _node.props) || {};
        var nodeClasses = (0, _reactAtomicMolecule.mixClass)(nodeProps.className, "item", {
          active: isActived
        });
        node = (0, _reactAtomicMolecule.build)(node)({
          key: nodeKey,
          "data-selected": isActived,
          className: nodeClasses,
          style: (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, Styles.tabItem), nodeProps.style),
          onClickCapture: handleTabPress({
            disableSwitch: disableSwitch,
            nodeKey: nodeKey,
            nodeProps: nodeProps,
            setLastSelected: setLastSelected,
            thisSelected: thisSelected,
            onTabItemWillPress: onTabItemWillPress,
            onTabItemPress: onTabItemPress
          })
        });
        tabMenuItems.push(node);
      } else {
        if (isActived) {
          contentView = node;
        }
      }
    });
  });
  return {
    hasSelected: hasSelected,
    contentView: contentView,
    tabMenuItems: tabMenuItems
  };
};
var useTabView = function useTabView(props) {
  var _props$disableSwitch = props.disableSwitch,
    disableSwitch = _props$disableSwitch === void 0 ? false : _props$disableSwitch,
    _props$rwd = props.rwd,
    rwd = _props$rwd === void 0 ? true : _props$rwd,
    _props$selected = props.selected,
    propsSelected = _props$selected === void 0 ? true : _props$selected,
    _props$menu = props.menu,
    menu = _props$menu === void 0 ? _reactAtomicMolecule.SemanticUI : _props$menu,
    _props$body = props.body,
    body = _props$body === void 0 ? _reactAtomicMolecule.SemanticUI : _props$body,
    id = props.id,
    style = props.style,
    children = props.children,
    contentStyle = props.contentStyle,
    menuStyle = props.menuStyle,
    leftMenu = props.leftMenu,
    rightMenu = props.rightMenu,
    bottom = props.bottom,
    left = props.left,
    right = props.right,
    onTabItemWillPress = props.onTabItemWillPress,
    onTabItemPress = props.onTabItemPress,
    onChange = props.onChange;
  (0, _reactAtomicMolecule.useCSS)(["tab"], "semantic");
  var _useState = (0, _react.useState)({
      current: propsSelected
    }),
    lastSelected = _useState[0],
    setHookLastSelected = _useState[1];
  var lastPropsSelected = (0, _react.useRef)();
  var thisSelected = (0, _react.useRef)();
  var setLastSelected = function setLastSelected(val) {
    return setHookLastSelected(function (_ref3) {
      var prev = _ref3.prev,
        current = _ref3.current;
      return {
        prev: current,
        current: val
      };
    });
  };
  (0, _react.useEffect)(function () {
    if (propsSelected !== lastPropsSelected.current) {
      lastPropsSelected.current = propsSelected;
      setLastSelected(propsSelected);
    }
  }, [propsSelected]);
  (0, _react.useEffect)(function () {
    if (lastSelected.prev !== lastSelected.current) {
      thisSelected.current = lastSelected.current;
      setTimeout(function () {
        (0, _callFunc["default"])(onChange, [thisSelected.current, {
          selected: thisSelected.current
        }]);
      });
    }
  }, [lastSelected]);
  var selectResult = handleSelected({
    nextSelect: lastSelected.current,
    children: children,
    thisSelected: thisSelected,
    setLastSelected: setLastSelected,
    disableSwitch: disableSwitch,
    onTabItemWillPress: onTabItemWillPress,
    onTabItemPress: onTabItemPress
  });
  if (!selectResult.hasSelected && propsSelected !== false) {
    selectResult = handleSelected({
      nextSelect: true,
      children: children,
      thisSelected: thisSelected,
      setLastSelected: setLastSelected,
      disableSwitch: disableSwitch,
      onTabItemWillPress: onTabItemWillPress,
      onTabItemPress: onTabItemPress
    });
    if (selectResult.hasSelected) {
      setTimeout(function () {
        return setLastSelected(thisSelected.current);
      });
    }
  }
  var _selectResult = selectResult,
    contentView = _selectResult.contentView,
    tabMenuItems = _selectResult.tabMenuItems;
  // Tab Menu
  if (leftMenu) {
    tabMenuItems.push((0, _reactAtomicMolecule.build)(leftMenu)({
      key: "l-menu"
    }));
  }
  if (rightMenu) {
    tabMenuItems.push((0, _reactAtomicMolecule.build)(rightMenu)({
      key: "r-menu"
    }));
  }
  var menuOpt = {
    top: !bottom && !left && !right,
    bottom: bottom,
    vertical: left || right,
    stackable: rwd
  };
  var expose = {
    getSelected: function getSelected() {
      return thisSelected.current;
    }
  };
  return {
    contentView: contentView,
    tabMenuItems: tabMenuItems,
    menuOpt: menuOpt,
    menuStyle: menuStyle,
    menu: menu,
    body: body,
    contentStyle: contentStyle,
    expose: expose,
    id: id,
    style: style
  };
};
var TabView = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var _useTabView = useTabView(props),
    contentView = _useTabView.contentView,
    tabMenuItems = _useTabView.tabMenuItems,
    menuOpt = _useTabView.menuOpt,
    menuStyle = _useTabView.menuStyle,
    menu = _useTabView.menu,
    body = _useTabView.body,
    contentStyle = _useTabView.contentStyle,
    expose = _useTabView.expose,
    id = _useTabView.id,
    style = _useTabView.style;
  (0, _react.useImperativeHandle)(ref, function () {
    return expose;
  }, []);
  var menuClasses = (0, _reactAtomicMolecule.mixClass)("attached tabular menu", menuOpt);
  var tabMenu = (0, _reactAtomicMolecule.build)(menu)({
    key: "menu",
    style: menuStyle,
    className: menuClasses
  }, tabMenuItems);
  var content;
  if (contentView) {
    // Tab Body
    var contentClasses = (0, _reactAtomicMolecule.mixClass)("attached tab segment active", {
      top: !menuOpt.top,
      bottom: menuOpt.top
    });
    content = (0, _reactAtomicMolecule.build)(body)({
      key: "content",
      style: (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, Styles.tabBody), contentStyle),
      className: contentClasses
    }, contentView);
  }
  var childOrder = menuOpt.top ? [tabMenu, content] : [content, tabMenu];
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactAtomicMolecule.SemanticUI, {
    style: style,
    id: id,
    className: "tab-view",
    children: childOrder
  });
});
TabView.displayName = "TabView";
var _default = exports["default"] = TabView;
var Styles = {
  tabBody: {
    boxSizing: "border-box"
  },
  tabItem: {
    boxSizing: "border-box",
    cursor: "pointer"
  }
};
module.exports = exports.default;