import _objectSpread from "reshow-runtime/es/helpers/objectSpread2";
import _classCallCheck from "reshow-runtime/es/helpers/classCallCheck";
import _createClass from "reshow-runtime/es/helpers/createClass";
import get from "get-object-value";
import { toInt } from "to-percent-js";
var keys = Object.keys;
var BEGIN = "0";
var END = "1";
var PER_PAGE_NUM = "perPageNum";
var TOTAL = "total";
var TOTAL_PAGE = "totalPage";
var CURRENT_PAGE = "currentPage";
var BACKWARD = "backward";
var FORWARD = "forward";
var LAST_PAGE = "lastPage";
var FIRST_PAGE = "firstPage";

/**
 * type: [begin|page]
 */
var TYPE = "type";
var TYPE_BEGIN = "begin";
var TYPE_PAGE = "page";

// url
var URL = "url";
var QUERY_B = "b";
var QUERY_PAGE = "page";
var Page = /*#__PURE__*/function () {
  function Page(currentPage, url, cal) {
    _classCallCheck(this, Page);
    this[BEGIN] = null;
    this[END] = null;
    this[PER_PAGE_NUM] = null;
    this[TOTAL] = null;
    this[TOTAL_PAGE] = null;
    this[CURRENT_PAGE] = null;
    this[TYPE] = null;
    this[URL] = url || null;
    //nav
    this[BACKWARD] = null;
    this[FORWARD] = null;
    this[FIRST_PAGE] = null;
    this[LAST_PAGE] = null;
    if (null != currentPage) {
      // force use type with page. need let currentPage have value and begin keep null
      this[CURRENT_PAGE] = currentPage;
      cal.process(this, _objectSpread(_objectSpread({}, cal.props), {}, {
        [BEGIN]: null
      }));
    }
  }
  _createClass(Page, [{
    key: "set",
    value: function set(key, value) {
      this[key] = value;
    }
  }]);
  return Page;
}();
var paginationCalculator = /*#__PURE__*/function () {
  function paginationCalculator(props) {
    _classCallCheck(this, paginationCalculator);
    props = _objectSpread({
      [TOTAL]: 0,
      query: {
        [QUERY_B]: QUERY_B,
        [QUERY_PAGE]: QUERY_PAGE
      }
    }, props);
    this.props = props;
  }
  _createClass(paginationCalculator, [{
    key: "set",
    value: function set(key, value) {
      this.props[key] = value;
    }
  }, {
    key: "sync",
    value: function sync(page, copyFrom) {
      var syncKeys = [PER_PAGE_NUM, TOTAL, CURRENT_PAGE, BEGIN];
      syncKeys.forEach(function (key) {
        if (null != copyFrom[key] && null == page[key]) {
          page.set(key, copyFrom[key]);
        }
      });
    }
  }, {
    key: "calBegin",
    value: function calBegin(page) {
      page[TOTAL_PAGE] = Math.ceil(page[TOTAL] / page[PER_PAGE_NUM]);
      if (isNaN(page[TOTAL_PAGE]) || 1 > page[TOTAL_PAGE]) {
        page[TOTAL_PAGE] = 1;
      }
      if (!page[CURRENT_PAGE] || 1 > page[CURRENT_PAGE]) {
        page[CURRENT_PAGE] = 1;
      }
      if (page[CURRENT_PAGE] > page[TOTAL_PAGE]) {
        page[CURRENT_PAGE] = page[TOTAL_PAGE];
      }
      page[BEGIN] = (page[CURRENT_PAGE] - 1) * page[PER_PAGE_NUM];
      page[END] = page[BEGIN] + page[PER_PAGE_NUM] - 1;
      var fixTotal = function fixTotal() {
        return page[TOTAL] ? page[TOTAL] - 1 : 0;
      };
      if (page[BEGIN] >= page[TOTAL]) {
        page[BEGIN] = fixTotal();
      }
      if (page[END] >= page[TOTAL]) {
        page[END] = fixTotal();
      }
      return page;
    }
  }, {
    key: "calNav",
    value: function calNav(page) {
      if (1 !== page[CURRENT_PAGE]) {
        page[BACKWARD] = page[CURRENT_PAGE] - 1;
        page[FIRST_PAGE] = 1;
      }
      if (page[TOTAL_PAGE] > page[CURRENT_PAGE]) {
        page[FORWARD] = page[CURRENT_PAGE] + 1;
        page[LAST_PAGE] = page[TOTAL_PAGE];
      }
    }
  }, {
    key: "calPageList",
    value: function calPageList(page, num) {
      if (num < 2) {
        console.error("Page list number need greater than 2, You set to [" + num + "].");
        return;
      }
      var middle = Math.floor(num / 2);
      var begin = page[CURRENT_PAGE] - middle;
      if (begin <= 0) {
        begin = 1;
      }
      if (num % 2 === 0) {
        begin++;
      }
      var end = begin + num - 1;
      if (end > page[TOTAL_PAGE]) {
        end = toInt(page[TOTAL_PAGE]) || 1;
      }
      if (end - begin < num - 1) {
        begin = end - num + 1;
        if (begin <= 0) {
          begin = 1;
        }
      }
      return {
        [BEGIN]: begin,
        [END]: end
      };
    }
  }, {
    key: "fixedPageList",
    value: function fixedPageList(_ref) {
      var {
        page,
        pages,
        liCount,
        num
      } = _ref;
      var list = keys(pages).map(function (key) {
        return pages[key];
      });
      if (num >= liCount[END]) {
        return list;
      }
      var lastKey = list.length - 1;
      var start = 0;
      var end = undefined;
      if (page[LAST_PAGE]) {
        end = -3;
      }
      if (page[FIRST_PAGE] && liCount[BEGIN] > 2) {
        start = 2;
        end = -2;
      }
      if (list[lastKey][CURRENT_PAGE] === page[LAST_PAGE] || list[lastKey] === CURRENT_PAGE) {
        end = undefined;
      }
      return list.slice(start, end);
    }
  }, {
    key: "genPageList",
    value: function genPageList(num, page, url) {
      if (isNaN(num) || !num) {
        num = 10;
      }
      if (null == page) {
        page = this.process(this.getPage());
      }
      this.calNav(page);
      var result = {
        [CURRENT_PAGE]: page
      };
      var pages = {};
      var current = page[CURRENT_PAGE];
      var liCount = this.calPageList(page, num);
      pages[current] = CURRENT_PAGE; // this line can not inside foreach, licount may not contain current
      for (var i = liCount[BEGIN], j = liCount[END]; i <= j; i++) {
        if (i !== current) {
          pages[i] = this.getPage(i, url, this);
        }
      }
      if (page[FIRST_PAGE]) {
        if (get(liCount, [BEGIN], -1) > page[FIRST_PAGE]) {
          var firstPage = this.getPage(page[FIRST_PAGE], url, this);
          if (2 === liCount[BEGIN]) {
            // index 1 is mean first page
            pages[1] = firstPage;
          } else {
            result[FIRST_PAGE] = firstPage;
          }
        }
      }
      if (page[FORWARD]) {
        result[CURRENT_PAGE][FORWARD] = this.getPage(page[FORWARD], url, this);
      }
      if (page[BACKWARD]) {
        result[CURRENT_PAGE][BACKWARD] = this.getPage(page[BACKWARD], url, this);
      }
      if (page && page[LAST_PAGE] && null == pages[page[LAST_PAGE]]) {
        var lastPage = this.getPage(page[LAST_PAGE], url, this);
        if (liCount[END] === page[LAST_PAGE]) {
          pages[liCount[END]] = lastPage;
        } else {
          result[LAST_PAGE] = lastPage;
        }
      }
      result.list = this.fixedPageList({
        page,
        pages,
        num,
        liCount
      });
      return result;
    }
  }, {
    key: "process",
    value: function process(page, copyFrom) {
      if (null == page) {
        page = this.process(this.getPage());
      }
      if (null == copyFrom) {
        copyFrom = this.props;
      }
      this.sync(page, copyFrom);
      if (!page[PER_PAGE_NUM]) {
        console.error("Per page number can't set to empty.");
      }
      if (null != page[BEGIN]) {
        page[CURRENT_PAGE] = Math.floor(page[BEGIN] / page[PER_PAGE_NUM]) + 1;
        page[TYPE] = TYPE_BEGIN;
      } else if (null != page[CURRENT_PAGE]) {
        page[TYPE] = TYPE_PAGE;
      } else {
        page[CURRENT_PAGE] = 1;
        page[TYPE] = TYPE_PAGE;
      }
      return this.calBegin(page);
    }
  }, {
    key: "getPage",
    value: function getPage(currentPage, url, cal) {
      return new Page(currentPage, url, cal);
    }
  }]);
  return paginationCalculator;
}();
export default paginationCalculator;
export { TOTAL, TOTAL_PAGE, CURRENT_PAGE, BEGIN, PER_PAGE_NUM };