import _objectSpread from "reshow-runtime/es/helpers/objectSpread2";
import _objectWithoutProperties from "reshow-runtime/es/helpers/objectWithoutProperties";
var _excluded = ["handler", "expose", "boxSizing", "listStyle", "hideList", "list", "icon", "children", "style", "titleStyle", "iconStyle", "textClassName", "compHd", "compBd", "compFt", "className", "refCb"];
import { isValidElement } from "react";
import { mergeRef } from "reshow-build";
import { build, useCSS, useLazyInject, mixClass, SemanticUI, Icon } from "react-atomic-molecule";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var DropdownUI = function DropdownUI(props) {
  injects = useLazyInject(InjectStyles, injects);
  useCSS(["dropdown"], "semantic");
  var {
      /*useDropdown*/
      handler = {},
      expose = {},
      /* Styles */
      boxSizing = "border-box",
      listStyle,
      /* Status */
      hideList,
      /* Component */
      list,
      icon = true,
      children,
      style,
      titleStyle,
      iconStyle,
      textClassName,
      compHd,
      compBd,
      compFt,
      className,
      refCb: _refCb
    } = props,
    otherProps = _objectWithoutProperties(props, _excluded);
  var textClasses = mixClass("text", textClassName);
  var thisText = /*#__PURE__*/_jsx(SemanticUI, {
    className: textClasses,
    style: _objectSpread(_objectSpread({}, Styles.label), titleStyle),
    children: children
  });
  var thisIcon = null;
  if (icon) {
    if (! /*#__PURE__*/isValidElement(icon)) {
      thisIcon = /*#__PURE__*/_jsx(Icon, {
        className: "dropdown-default-icon dropdown icon",
        style: iconStyle
      });
    } else {
      thisIcon = icon;
    }
  }
  var thisList = null;
  if (!hideList && list) {
    thisList = build(list)({
      style: _objectSpread(_objectSpread({}, Styles.list), listStyle),
      refCb: handler.listEl,
      onClick: handler.listClick,
      onTouchStart: handler.touchStart
    });
  }
  var thisClass = mixClass("dropdown", className);
  return /*#__PURE__*/_jsxs(SemanticUI, _objectSpread(_objectSpread({}, otherProps), {}, {
    style: _objectSpread(_objectSpread(_objectSpread({}, Styles.container), style), {}, {
      boxSizing
    }),
    className: thisClass,
    refCb: function refCb(el) {
      return mergeRef(el, [handler.thisEl, _refCb]);
    },
    onClick: handler.dropdownClick,
    children: [compHd, thisText, thisIcon, compBd, thisList, compFt]
  }));
};
export default DropdownUI;
var Styles = {
  container: {
    border: "none",
    boxShadow: "none",
    minHeight: "auto"
  },
  label: {
    display: "inline-block"
  },
  list: {
    boxSizing: "inherit",
    maxHeight: "50vh",
    overflow: "auto"
  }
};
var injects;
var InjectStyles = {
  resetSelectionBorderColor: [{
    borderColor: "inherit"
  }, [".selection.active.dropdown .menu.ui", ".ui.selection.active.dropdown:hover .menu.ui"].join(",")],
  defaultIcon: [{
    transform: ["rotate(180deg)"]
  }, [".ui.simple.dropdown:hover .dropdown-default-icon", ".ui.dropdown.active .dropdown-default-icon"].join(",")],
  initMenu: [{
    display: "none !important"
  }, ".ui.simple.dropdown .menu"],
  activeMenu: [{
    display: "block !important"
  }, [".ui.dropdown.active>.menu", ".ui.simple.dropdown:hover>.menu"].join(",")],
  /*https://github.com/fomantic/Fomantic-UI/pull/1209/files*/
  fixMinHeight: [{
    boxSizing: "inherit"
  }, ".ui.dropdown .menu>.item"],
  /*upward*/
  upward: [{
    top: "auto"
  }, [".ui.simple.upward.dropdown .menu", ".ui.simple.upward.active.dropdown>.menu", ".ui.simple.upward.dropdown:hover>.menu"].join(",")]
};