import _objectWithoutProperties from "reshow-runtime/es/helpers/objectWithoutProperties";
import _objectSpread from "reshow-runtime/es/helpers/objectSpread2";
var _Divider;
var _excluded = ["icon", "children", "header", "divider"],
  _excluded2 = ["dropdownComponent", "menuComponent", "itemComponent", "labelLocator", "valueLocator", "iconLocator", "headerLocator", "dividerLocator", "itemLocator", "itemsLocator", "highlighter", "onSelect", "useScrollToSelect", "alwaysOpen", "active", "hideTitle", "search", "defaultValue", "value", "placeholder", "options", "name", "onBeforeChange", "onChange", "wrapRefCb", "refCb", "inputProps"];
// @ts-check
import { build, mixClass, mergeRef, Divider, Menu, Item, Icon, Header, SemanticUI } from "react-atomic-molecule";
import callfunc from "call-func";
import DropdownUI from "../molecules/DropdownUI.mjs";
import defaultLocator from "../../defaultLocator.mjs";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var SelectMenu = function SelectMenu(props) {
  return /*#__PURE__*/_jsx(Menu, _objectSpread({}, props));
};
var SelectItem = function SelectItem(_ref) {
  var {
      icon,
      children,
      header,
      divider
    } = _ref,
    props = _objectWithoutProperties(_ref, _excluded);
  var thisIcon;
  if (icon) {
    thisIcon = /*#__PURE__*/_jsx(Icon, {
      children: build(icon)()
    });
  }
  var comp = [/*#__PURE__*/_jsxs(Item, _objectSpread(_objectSpread({}, props), {}, {
    children: [thisIcon, children]
  }), "item")];
  if (divider) {
    comp.unshift(_Divider || (_Divider = /*#__PURE__*/_jsx(Divider, {
      ui: false
    }, "divider")));
  }
  if (header) {
    comp.unshift( /*#__PURE__*/_jsx(Header, {
      ui: false,
      children: header
    }, header));
  }
  return comp;
};
var SelectUI = function SelectUI(props) {
  var {
      dropdownComponent = DropdownUI,
      menuComponent = SelectMenu,
      itemComponent = SelectItem,
      labelLocator = defaultLocator.label,
      valueLocator = defaultLocator.value,
      iconLocator = defaultLocator.icon,
      headerLocator = defaultLocator.header,
      dividerLocator = defaultLocator.divider,
      itemLocator = defaultLocator.item,
      itemsLocator = defaultLocator.items,
      highlighter = function (d) {
        return d;
      },
      onSelect = function () {},
      useScrollToSelect = [],
      alwaysOpen,
      active,
      hideTitle,
      search,
      defaultValue,
      value,
      placeholder,
      options,
      name,
      onBeforeChange,
      onChange,
      wrapRefCb,
      refCb,
      inputProps
    } = props,
    restProps = _objectWithoutProperties(props, _excluded2);
  var thisPlaceholder = null;
  if (placeholder) {
    thisPlaceholder = /*#__PURE__*/_jsx(SemanticUI, {
      style: Styles.dropdownPlaceholder,
      children: placeholder
    });
  }
  var thisSelected = value;
  var thisList = null;
  var [lastRoot] = callfunc(useScrollToSelect, [props]);
  if (options && options.length) {
    var prevHeader;
    thisList = build(menuComponent)(null, itemsLocator(options).map(function (l, itemIndex) {
      l = itemLocator(l);
      var optionValue = valueLocator(l);
      var optionText = labelLocator(l);
      var itemIcon = iconLocator(l);
      var header = headerLocator(l);
      var divider = dividerLocator(l);
      var active = null;
      if (value === optionValue) {
        thisSelected = optionText;
        active = true;
      }
      var thisHeader = null;
      if (header !== prevHeader) {
        prevHeader = header;
        thisHeader = header;
      }
      var selected = restProps["data-selected-index"] === itemIndex;
      return build(itemComponent)({
        key: optionValue,
        onClick: onSelect(l),
        "data-v": optionValue,
        "data-item-inex": itemIndex,
        className: mixClass({
          active,
          selected
        }),
        icon: itemIcon,
        header: thisHeader,
        divider
      }, highlighter(optionText, optionValue, l));
    }));
  }
  var inputAttr;
  if (search) {
    inputAttr = {
      className: "search",
      placeholder: "Type or search a command",
      style: {
        border: "none",
        boxSizing: "border-box"
      },
      type: "search"
    };
  } else {
    inputAttr = {
      type: "hidden"
    };
  }
  var compHd = /*#__PURE__*/_jsx(SemanticUI, _objectSpread({
    atom: "input",
    refCb: refCb,
    name: name,
    value: value || ""
  }, _objectSpread(_objectSpread({}, inputAttr), inputProps)), "input");
  var handleWrapRefCb = function handleWrapRefCb(el) {
    return mergeRef(el, [wrapRefCb, lastRoot]);
  };
  return build(dropdownComponent)(_objectSpread(_objectSpread({}, restProps), {}, {
    refCb: handleWrapRefCb,
    list: thisList,
    compHd,
    className: mixClass(props.className, "selection", {
      search,
      active: alwaysOpen || active
    })
  }), hideTitle ? null : thisSelected || thisPlaceholder);
};
export default SelectUI;
var Styles = {
  dropdownPlaceholder: {
    color: "#ccc"
  }
};