import _objectSpread from "reshow-runtime/es/helpers/objectSpread2";
import _classCallCheck from "reshow-runtime/es/helpers/classCallCheck";
import _createClass from "reshow-runtime/es/helpers/createClass";
import _assertThisInitialized from "reshow-runtime/es/helpers/assertThisInitialized";
import _inherits from "reshow-runtime/es/helpers/inherits";
import _createSuper from "reshow-runtime/es/helpers/createSuper";
import _defineProperty from "reshow-runtime/es/helpers/defineProperty";
//@ts-check

import * as React from "react";
var {
  PureComponent
} = React;
import { mixClass, Icon, SemanticUI, Item, Title, Content } from "react-atomic-molecule";
import get from "get-object-value";
import Dropdown from "ricon/Dropdown";
import { jsxs as _jsxs } from "react/jsx-runtime";
import { jsx as _jsx } from "react/jsx-runtime";
var AccordionItem = function AccordionItem(_ref) {
  var {
    title,
    content,
    iconLeft,
    iconRight,
    titleClasses,
    contentClasses,
    onClick
  } = _ref;
  return /*#__PURE__*/_jsxs(Item, {
    children: [/*#__PURE__*/_jsxs(Title, {
      onClick,
      className: titleClasses,
      children: [iconLeft, title, iconRight]
    }), /*#__PURE__*/_jsx(Content, {
      className: contentClasses,
      children: content
    })]
  });
};
var Accordion = /*#__PURE__*/function (_PureComponent) {
  _inherits(Accordion, _PureComponent);
  var _super = _createSuper(Accordion);
  function Accordion() {
    var _this;
    _classCallCheck(this, Accordion);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _defineProperty(_assertThisInitialized(_this), "state", {
      isActives: {}
    });
    return _this;
  }
  _createClass(Accordion, [{
    key: "handleClick",
    value:
    /**
     * @param {string} name
     */
    function handleClick(name) {
      this.setState(function (_ref2) {
        var {
          isActives
        } = _ref2;
        isActives[name] = !get(isActives, [name], false);
        return _objectSpread({}, isActives);
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var {
        className,
        items,
        iconLocRight,
        iconLocLeft,
        iconOpen,
        iconClose
      } = this.props;
      var {
        isActives
      } = this.state;
      var classes = mixClass("accordion", className);
      return /*#__PURE__*/_jsx(SemanticUI, {
        className: classes,
        children: items.map(
        /**
         * @param {any} item
         * @param {number} key
         */
        function (item, key) {
          var itemProps = get(item, ["props"], {});
          var name = itemProps.name || key;
          var isActive = !!isActives[name];
          var titleClasses = mixClass({
            active: isActive
          });
          var contentClasses = mixClass({
            active: isActive
          });
          var icon = /*#__PURE__*/_jsx(Icon, {
            style: Styles.icon,
            children: isActive ? iconOpen : iconClose
          });
          var iconLeft;
          var iconRight;
          if (iconLocRight) {
            iconRight = icon;
          } else if (iconLocLeft) {
            iconLeft = icon;
          }
          return /*#__PURE__*/_jsx(AccordionItem, _objectSpread({}, _objectSpread(_objectSpread({}, item), {}, {
            name,
            titleClasses,
            contentClasses,
            iconLeft,
            iconRight,
            key: name,
            onClick: _this2.handleClick.bind(_this2, name)
          })));
        })
      });
    }
  }]);
  return Accordion;
}(PureComponent);
_defineProperty(Accordion, "defaultProps", {
  iconOpen: /*#__PURE__*/_jsx(Dropdown, {}),
  iconClose: /*#__PURE__*/_jsx(Dropdown, {
    type: "left"
  }),
  iconLocRight: true,
  iconLocLeft: false
});
export default Accordion;
var Styles = {
  icon: {
    width: 24,
    height: 24
  }
};