import _objectSpread from "reshow-runtime/es/helpers/objectSpread2";
import _objectWithoutProperties from "reshow-runtime/es/helpers/objectWithoutProperties";
var _SemanticUI;
var _excluded = ["className", "children", "divider", "dividerStyle", "style"];
import { Children } from "react";
import { build, mixClass, SemanticUI } from "react-atomic-molecule";
import get from "get-object-value";
import { jsx as _jsx } from "react/jsx-runtime";
var Breadcrumb = function Breadcrumb(props) {
  var {
      className,
      children,
      divider,
      dividerStyle,
      style
    } = props,
    reset = _objectWithoutProperties(props, _excluded);
  var itemList = [];
  var defaultDivider = build(divider || _SemanticUI || (_SemanticUI = /*#__PURE__*/_jsx(SemanticUI, {
    children: " / "
  })));
  Children.forEach(children, function (node, k) {
    if (!node) {
      return;
    }
    var nodeProps = get(node, ["props"], {});
    itemList.push(build(node)({
      key: k,
      className: mixClass(nodeProps.className, "section")
    }));
    var nodeDataDivider = nodeProps["data-divider"];
    var thisDivider = nodeDataDivider ? build(nodeDataDivider) : defaultDivider;
    var dividerProps = get(divider, ["props"], function () {
      return get(nodeProps.divider, ["props"], {});
    });
    itemList.push(thisDivider({
      key: k + "-div",
      style: _objectSpread(_objectSpread({}, dividerProps.style), dividerStyle),
      className: mixClass(dividerProps.className, "divider")
    }));
  });
  if (itemList.length) {
    itemList.pop();
  }
  return /*#__PURE__*/_jsx(SemanticUI, _objectSpread(_objectSpread({}, reset), {}, {
    style: _objectSpread(_objectSpread({}, Styles.container), style),
    className: mixClass("breadcrumb", className),
    children: itemList
  }));
};
export default Breadcrumb;
var Styles = {
  container: {
    lineHeight: 1.8
  }
};