import _objectWithoutProperties from "reshow-runtime/es/helpers/objectWithoutProperties";
import _objectSpread from "reshow-runtime/es/helpers/objectSpread2";
var _excluded = ["isLastPage", "text"],
  _excluded2 = ["text"];
import callfunc from "call-func";
import get from "get-object-value";
import { build, min, mixClass, useLazyInject, Item, Menu } from "react-atomic-molecule";
import { jsx as _jsx } from "react/jsx-runtime";
import { createElement as _createElement } from "react";
import { jsxs as _jsxs } from "react/jsx-runtime";
var isArray = Array.isArray;
var plusOne = function plusOne(i) {
  return i + 1;
};
var getFromTo = function getFromTo(from, to) {
  return plusOne(from) + "-" + plusOne(to);
};
var keys = Object.keys;
var BasePage = function BasePage(props) {
  var {
    onPageChange,
    component,
    className,
    children,
    style,
    url,
    rel
  } = props;
  var classes = mixClass(get(component, ["props", "className"]), className, "item link");
  var onClick = onPageChange ? function () {
    return callfunc(onPageChange, [{
      begin: props[0],
      end: props[1],
      page: props["currentPage"],
      perPageNum: props["perPageNum"]
    }]);
  } : null;
  return build(component)({
    rel,
    title: getFromTo(props[0], props[1]),
    className: classes,
    href: url,
    style,
    onClick,
    "data-begin": props[0],
    "data-end": props[1],
    "data-page": props["currentPage"],
    "data-per-page-num": props["perPageNum"]
  }, children);
};
var Page = function Page(props) {
  return /*#__PURE__*/_jsx(BasePage, _objectSpread(_objectSpread({}, props), {}, {
    children: props.currentPage
  }));
};
var Forward = function Forward(_ref) {
  var {
      isLastPage,
      text
    } = _ref,
    props = _objectWithoutProperties(_ref, _excluded);
  return /*#__PURE__*/_jsx(BasePage, _objectSpread(_objectSpread({}, props), {}, {
    rel: "next",
    children: isLastPage ? props.currentPage : text
  }));
};
var Backward = function Backward(_ref2) {
  var {
      text
    } = _ref2,
    props = _objectWithoutProperties(_ref2, _excluded2);
  return /*#__PURE__*/_jsx(BasePage, _objectSpread(_objectSpread({}, props), {}, {
    rel: "prev",
    children: props.currentPage === 1 ? props.currentPage : text
  }));
};
var Current = function Current(props) {
  return /*#__PURE__*/_jsx(Item, {
    style: props.style,
    title: getFromTo(props[0], props[1]),
    className: mixClass("active", props.className),
    children: props.currentPage
  });
};
var FirstPage = function FirstPage(props) {
  return /*#__PURE__*/_jsx(Page, _objectSpread({}, props));
};
var LastPage = function LastPage(props) {
  return /*#__PURE__*/_jsx(Page, _objectSpread({}, props));
};
var Ellipsis = function Ellipsis(props) {
  return /*#__PURE__*/_jsx(Item, {
    className: "disabled ellipsis",
    style: _objectSpread({
      minWidth: 0,
      width: 0
    }, props.style),
    children: "..."
  });
};
var Pagination = function Pagination(pg) {
  injects = useLazyInject(InjectStyles, injects);
  var {
    linkComponent,
    onPageChange,
    forwardText,
    backwardText,
    ui,
    currentPageProps = {}
  } = pg;
  var firstPage;
  var firstEllipsis;
  var lastPage;
  var lastEllipsis;
  var pageProps = pg.pageProps || {};
  pageProps.onPageChange = onPageChange;
  pageProps.component = linkComponent;
  var ellipsisProps = _objectSpread(_objectSpread({}, pageProps), {}, {
    onPageChange: null
  });
  if (pg.firstPage) {
    firstPage = /*#__PURE__*/_jsx(FirstPage, _objectSpread(_objectSpread({}, pg.firstPage), pageProps));
    firstEllipsis = /*#__PURE__*/_jsx(Ellipsis, _objectSpread({}, ellipsisProps));
  }
  if (pg.lastPage) {
    lastPage = /*#__PURE__*/_jsx(LastPage, _objectSpread(_objectSpread({}, pg.lastPage), pageProps));
    lastEllipsis = /*#__PURE__*/_jsx(Ellipsis, _objectSpread({}, ellipsisProps));
  }
  var pgList = pg.list;
  if (!isArray(pgList)) {
    console.error("Page list not array", pg);
  }
  return /*#__PURE__*/_jsxs(Menu, {
    className: "compact pagination",
    ui: ui,
    children: [firstPage, firstEllipsis, pgList.map(function (v, k) {
      var current = pg.currentPage;
      if (v.currentPage) {
        if (current.backward && current.backward.currentPage === v.currentPage || current.forward && current.forward.currentPage === v.currentPage) {
          return null;
        }
        return /*#__PURE__*/_createElement(Page, _objectSpread(_objectSpread({}, pageProps), {}, {
          key: k
        }, v));
      } else {
        var re = [];
        if (current.backward) {
          re.push( /*#__PURE__*/_jsx(Backward, _objectSpread(_objectSpread(_objectSpread({
            text: backwardText
          }, current.backward), pageProps), {}, {
            style: _objectSpread(_objectSpread({}, pageProps.style), {}, {
              display: "flex"
            })
          })));
        }
        re.push( /*#__PURE__*/_jsx(Current, _objectSpread(_objectSpread(_objectSpread(_objectSpread({}, pageProps), current), currentPageProps), {}, {
          style: _objectSpread(_objectSpread(_objectSpread({}, pageProps.style), currentPageProps.style), {}, {
            display: "flex"
          })
        }), k));
        if (current.forward) {
          re.push( /*#__PURE__*/_jsx(Forward, _objectSpread(_objectSpread(_objectSpread({
            isLastPage: pgList.length - 2 === k
          }, current.forward), {}, {
            text: forwardText
          }, pageProps), {}, {
            style: _objectSpread(_objectSpread({}, pageProps.style), {}, {
              display: "flex"
            })
          })));
        }
        return re;
      }
    }), lastEllipsis, lastPage]
  });
};
Pagination.defaultProps = {
  linkComponent: "a",
  forwardText: "> Next",
  backwardText: "<"
};
export default Pagination;
var injects;
var pgCssSelector = ".pagination.ui.menu:not(.vertical) .item";
var InjectStyles = {
  hidePg: [{
    display: "none",
    minWidth: "2rem",
    justifyContent: "center"
  }, pgCssSelector],
  showPg: [{
    display: "flex"
  }, [min.sm, pgCssSelector]]
};