import _objectSpread from "reshow-runtime/es/helpers/objectSpread2";
import _objectWithoutProperties from "reshow-runtime/es/helpers/objectWithoutProperties";
import _classCallCheck from "reshow-runtime/es/helpers/classCallCheck";
import _createClass from "reshow-runtime/es/helpers/createClass";
import _inherits from "reshow-runtime/es/helpers/inherits";
import _createSuper from "reshow-runtime/es/helpers/createSuper";
import _defineProperty from "reshow-runtime/es/helpers/defineProperty";
var _excluded = ["hideOnlyOne", "pageProps", "currentPageProps", "onPageChange", "pageListNumber", "total", "begin", "currentPage", "perPageNum", "ui"];
import { PureComponent } from "react";
import { SemanticUI } from "react-atomic-molecule";
import { toInt } from "to-percent-js";
import get from "get-object-value";
import Pagination from "../organisms/Pagination.mjs";
import paginationCalculator, { TOTAL, BEGIN, CURRENT_PAGE, PER_PAGE_NUM } from "../../paginationCalculator.mjs";
import { jsx as _jsx } from "react/jsx-runtime";
var PaginationController = /*#__PURE__*/function (_PureComponent) {
  _inherits(PaginationController, _PureComponent);
  var _super = _createSuper(PaginationController);
  function PaginationController() {
    _classCallCheck(this, PaginationController);
    return _super.apply(this, arguments);
  }
  _createClass(PaginationController, [{
    key: "getPaginationData",
    value: function getPaginationData() {
      if (!this.cal) {
        this.cal = new paginationCalculator();
      }
      var cal = this.cal;
      var {
        pageListNumber,
        total,
        begin,
        currentPage,
        perPageNum
      } = this.props;
      cal.set(TOTAL, toInt(total));
      if (null != perPageNum) {
        cal.set(PER_PAGE_NUM, toInt(perPageNum));
      }
      if (null != begin) {
        cal.set(BEGIN, toInt(begin));
      } else {
        cal.set(BEGIN, null); // when "type = page" need reset begin
        cal.set(CURRENT_PAGE, toInt(currentPage));
      }
      return cal.genPageList(toInt(pageListNumber));
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        {
          hideOnlyOne,
          pageProps,
          currentPageProps,
          onPageChange,
          pageListNumber,
          total,
          begin,
          currentPage,
          perPageNum,
          ui
        } = _this$props,
        otherProps = _objectWithoutProperties(_this$props, _excluded);
      var data = this.getPaginationData();
      if (hideOnlyOne) {
        var liLen = get(data.list, ["length"], 0);
        if (liLen < 2) {
          return null;
        }
      }
      return /*#__PURE__*/_jsx(SemanticUI, _objectSpread(_objectSpread({}, otherProps), {}, {
        ui: ui,
        children: /*#__PURE__*/_jsx(Pagination, _objectSpread(_objectSpread({}, data), {}, {
          onPageChange: onPageChange,
          ui: ui,
          pageProps: pageProps,
          currentPageProps: currentPageProps
        }))
      }));
    }
  }]);
  return PaginationController;
}(PureComponent);
_defineProperty(PaginationController, "defaultProps", {
  perPageNum: 10
});
export default PaginationController;