import _objectSpread from "reshow-runtime/es/helpers/objectSpread2";
// @ts-check
import { forwardRef, useImperativeHandle } from "react";
import SelectUI from "../molecules/SelectUI.mjs";
import Dropdown from "../organisms/Dropdown.mjs";
import { useSelect } from "../../hooks/useSelect.mjs";

/**
 * @type React.FC<any>
 * @returns {React.ReactElement}
 */
import { jsx as _jsx } from "react/jsx-runtime";
var Select = /*#__PURE__*/forwardRef(function (props, ref) {
  var {
    handler,
    expose,
    labelLocator,
    valueLocator
  } = useSelect(props);
  useImperativeHandle(ref, function () {
    return expose;
  }, []);
  return /*#__PURE__*/_jsx(SelectUI, _objectSpread(_objectSpread({}, props), {}, {
    labelLocator: labelLocator,
    valueLocator: valueLocator,
    dropdownComponent: Dropdown,
    value: expose.getValue(),
    onSelect: handler.select
  }));
});
Select.displayName = "Select";
export default Select;