import _objectWithoutProperties from "reshow-runtime/es/helpers/objectWithoutProperties";
import _objectSpread from "reshow-runtime/es/helpers/objectSpread2";
var _DefaultIcon, _DefaultIcon2;
var _excluded = ["buildComp", "className", "name", "text", "type"],
  _excluded2 = ["type", "component", "linkComponent", "menus", "rootActiveClass", "rootInactiveClass", "root", "on", "onSwitch", "defaultOnIcon", "defaultOffIcon", "iconStyle", "hamburgerStyle", "className", "menuOrder", "shrink"];
import { useEffect, useCallback, useRef } from "react";
import { build, mixClass, reactStyle, Icon, Rail, SemanticUI } from "react-atomic-molecule";
import { useStore } from "reshow-flux";
import Hamburger from "ricon/HamburgerToArrow";
import { toJS } from "get-object-value";
import { hasClass, removeClass } from "class-lib";
import { queryOne } from "css-query-selector";
import getOffset from "getoffset";
import callfunc from "call-func";
import { KEYS } from "reshow-constant";
import navigationStore, { navigationDispatch } from "../../stores/navigationStore.mjs";
import { createElement as _createElement } from "react";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var getMenuByArray = function getMenuByArray(onClick) {
  return function (arr, component, type, menuOrder) {
    if (!arr) {
      return null;
    }
    var results = [];
    var buildComp = build(component);
    (menuOrder || KEYS(arr)).forEach(function (key) {
      results.push( /*#__PURE__*/_createElement(SideMenuItem, _objectSpread(_objectSpread({}, arr[key]), {}, {
        key: key,
        type: type,
        name: key,
        onClick: onClick,
        buildComp: buildComp
      })));
    });
    return results;
  };
};
var SideMenuItem = function SideMenuItem(props) {
  var {
      buildComp,
      className,
      name,
      text,
      type
    } = props,
    others = _objectWithoutProperties(props, _excluded);
  var lastV = useRef();
  var active = useStore(navigationStore, function (emit) {
    if (emit === void 0) {
      emit = {};
    }
    var {
      storeState,
      notify
    } = emit.current || {};
    if (emit.current) {
      var {
        activeMenu
      } = storeState.get(type);
      if (name !== activeMenu && lastV.current) {
        emit.current.state = false;
        notify();
      } else if (name === activeMenu) {
        emit.current.state = true;
        notify();
        lastV.current = true;
      }
    } else {
      return false;
    }
  });
  var classes = mixClass(className, "item", {
    active
  });
  return buildComp(_objectSpread(_objectSpread({}, others), {}, {
    className: classes,
    name
  }), text);
};
var DefaultIcon = function DefaultIcon(_ref) {
  var {
    className,
    on,
    right,
    onClick,
    iconStyle,
    hamburgerStyle
  } = _ref;
  return /*#__PURE__*/_jsx(Icon, {
    onClick: onClick,
    className: mixClass(className, "hamburger-icon"),
    styles: reactStyle(_objectSpread(_objectSpread({}, Styles.icon), iconStyle), false, false),
    children: /*#__PURE__*/_jsx(Hamburger, {
      on: on,
      right: right,
      styles: reactStyle(_objectSpread(_objectSpread({}, Styles.hamburger), hamburgerStyle), false, false)
    })
  });
};
var SideMenuContainer = function SideMenuContainer(_ref2) {
  var {
    children,
    type,
    onSwitch,
    lastOn,
    updateRoot,
    defaultOnIcon,
    defaultOffIcon,
    iconStyle,
    hamburgerStyle,
    className,
    shrink
  } = _ref2;
  var on = useStore(navigationStore, function (emit) {
    if (emit === void 0) {
      emit = {};
    }
    var {
      storeState,
      notify
    } = emit.current || {};
    if (emit.current) {
      var {
        on: _on
      } = storeState.get(type);
      if (lastOn.current !== _on) {
        emit.current.state = _on;
        notify();
        lastOn.current = _on;
        updateRoot(_on);
      }
    } else {
      return lastOn.current;
    }
  });
  var isInit = null == on;

  // setup thisDefaultOffIcon
  var defaultOff = isInit ? false : on;
  var thisDefaultOffIcon = defaultOffIcon;
  if (!thisDefaultOffIcon) {
    thisDefaultOffIcon = _DefaultIcon || (_DefaultIcon = /*#__PURE__*/_jsx(DefaultIcon, {}));
  }
  thisDefaultOffIcon = build(thisDefaultOffIcon)({
    on: defaultOff,
    onClick: onSwitch(defaultOff),
    className: "default-off",
    iconStyle,
    hamburgerStyle
  });

  // setup thisDefaultOnIcon
  var thisDefaultOnIcon = null;
  if (shrink) {
    var defaultOn = isInit ? true : on;
    thisDefaultOnIcon = defaultOnIcon;
    if (!thisDefaultOnIcon) {
      thisDefaultOnIcon = _DefaultIcon2 || (_DefaultIcon2 = /*#__PURE__*/_jsx(DefaultIcon, {}));
    }
    thisDefaultOnIcon = build(thisDefaultOnIcon)({
      on: true,
      right: !defaultOn,
      onClick: onSwitch(defaultOn),
      className: "default-on",
      iconStyle,
      hamburgerStyle
    });
  }
  var classes = mixClass({
    active: on,
    inactive: on === false
  }, "sidebar-menu", className);
  return /*#__PURE__*/_jsxs(Rail, {
    className: classes,
    children: [children, thisDefaultOnIcon, thisDefaultOffIcon]
  });
};
var useSideMenu = function useSideMenu(props) {
  var _ref3 = props || {},
    {
      type = "default",
      component = SemanticUI,
      linkComponent = "a",
      menus = [],
      rootActiveClass = "side-menu-active",
      rootInactiveClass = "side-menu-inactive",
      root,
      on: propsOn,
      onSwitch,
      defaultOnIcon,
      defaultOffIcon,
      iconStyle,
      hamburgerStyle,
      className,
      menuOrder,
      shrink
    } = _ref3,
    others = _objectWithoutProperties(_ref3, _excluded2);
  var lastOn = useRef();
  useEffect(function () {
    if (null != propsOn) {
      navigationDispatch(type, {
        on: propsOn
      });
    }
  }, [propsOn]);
  useEffect(function () {
    return function () {
      var thisRoot = getRoot();
      thisRoot.className = removeClass(thisRoot.className, rootActiveClass);
      thisRoot.className = removeClass(thisRoot.className, rootInactiveClass);
    };
  }, []);
  var getRoot = useCallback(function () {
    return root !== null && root !== void 0 ? root : document.body;
  }, [root]);
  var updateRoot = useCallback(function (on) {
    var thisRoot = getRoot();
    if (!thisRoot) {
      console.wanr("root not found");
      return;
    }
    if (on) {
      thisRoot.className = mixClass(thisRoot.className, rootActiveClass);
      thisRoot.className = removeClass(thisRoot.className, rootInactiveClass);
    } else {
      thisRoot.className = mixClass(thisRoot.className, rootInactiveClass);
      thisRoot.className = removeClass(thisRoot.className, rootActiveClass);
    }
  }, [rootActiveClass, rootInactiveClass]);
  var handleSwitch = useCallback(function (stateOn) {
    return function (e) {
      var isValidStateOn = "boolean" === typeof stateOn;
      var on = !(isValidStateOn ? stateOn : lastOn.current);
      var defaultOff = getOffset(queryOne(".sidebar-menu .default-off"));
      var isSet = isValidStateOn || defaultOff.w && defaultOff.h;
      if (isSet) {
        navigationDispatch(type, {
          on
        });
      }
      e.on = on;
      e.isSet = isSet;
      callfunc(onSwitch, [e, on, isSet]);
    };
  }, [type, onSwitch]);
  var menuItems = getMenuByArray(handleSwitch())(toJS(menus), linkComponent, type, toJS(menuOrder));
  return {
    menuItems,
    component,
    type,
    handleSwitch,
    lastOn,
    updateRoot,
    defaultOnIcon,
    defaultOffIcon,
    iconStyle,
    hamburgerStyle,
    className,
    shrink,
    others
  };
};
var SideMenu = function SideMenu(props) {
  var {
    menuItems,
    component,
    type,
    handleSwitch,
    lastOn,
    updateRoot,
    defaultOnIcon,
    defaultOffIcon,
    iconStyle,
    hamburgerStyle,
    className,
    shrink,
    others
  } = useSideMenu(props);
  var menuElement = build(component)(others, menuItems);
  return /*#__PURE__*/_jsx(SideMenuContainer, {
    type: type,
    onSwitch: handleSwitch,
    lastOn: lastOn,
    updateRoot: updateRoot,
    defaultOnIcon: defaultOnIcon,
    defaultOffIcon: defaultOffIcon,
    iconStyle: iconStyle,
    hamburgerStyle: hamburgerStyle,
    className: className,
    shrink: shrink,
    children: menuElement
  });
};
export default SideMenu;
var Styles = {
  icon: {
    display: null,
    background: "#000",
    padding: 5,
    width: 24,
    height: 24,
    position: "fixed",
    top: 0,
    left: 0,
    zIndex: 1,
    cursor: "pointer",
    opacity: ".5",
    transition: ["all 0.2s ease-out"]
  },
  hamburger: {
    fill: "#fff"
  }
};